function Preload()
{
	this.source = source_preloadCB
	this.load = load_preloadCB
	this.rewrite = rewrite_preloadCB
	this.resize = resize_preloadCB
	this.clear = clear_preloadCB
	this.info = info_preloadCB
	this.init = true
	this.paused = false
	this.cleared = false
	this.f=null
}

function source_preloadCB()
{
	var s=''
	if(_moz||_ie) s+='<iframe frameborder=0 style="position:absolute;width:10px;left:-200px;" name="f_preload_frameset" id="f_preload" src=""></iframe>'	
	s+=lyr(0,0,"","class=z1000",false,"bgpreload",mw,mh)
	s+=lyr(0,0,getButton(true,true),"class=z1000", false,"btnpreload_pause",mw,mh)
	s+=lyr(0,0,getButton(false,true),"class=z1000", false,"btnpreload_continue",mw,mh)	
	s+=lyr(0,0,getButton(),"class=z1000", false,"btnpreload_right",mw,mh)
	s+=lyr(0,0,'<span class="preload"><nobr>&nbsp;'+_lab.preloadPaused+" "+_ktop.book.pages.length+"/"+_ktop.book.pages.length+'&nbsp;</nobr></span>',' class="z1000" ',false,"txt_pause",mw,mh)
	s+=lyr(0,0,'<span class="preload"><nobr>&nbsp;'+_lab.preloading+" "+_ktop.book.pages.length+"/"+_ktop.book.pages.length+'&nbsp;</nobr></span>',' class="z1000" ', false,"txt_continue",mw,mh)
	return s
}
function load_preloadCB() 
{
	var cw,pw,obj
	cw = layerWidth("btnpreload_continue")
	pw = layerWidth("btnpreload_pause")

	obj = gui.preload
	obj.w = Math.max(obj.lpw,obj.lcw)+Math.max(cw,pw)+obj.rw

	reWriteLayer(getButton(true),"btnpreload_pause")
	reWriteLayer(getButton(false),"btnpreload_continue")

	cw = layerWidth("txt_continue")
	pw = layerWidth("txt_pause")
	
	obj = gui.bgpreload
	obj.w = obj.lw+Math.max(cw,pw)+gui.preload.w+gui.preload.rw+obj.rw

	reWriteLayer( _main.skinImg("notile.gif","bl",0,0,obj.lw,obj.h,obj.dx,0)+
		_main.skinImg("htile.gif","btn",obj.lw,0,obj.w-obj.lw-obj.rw,obj.h,0,obj.dy)+
		_main.skinImg("notile.gif","br",obj.w-obj.rw,0,obj.rw,obj.h,obj.dx+obj.lw,0),"bgpreload")

	this.f=getFrame("f_preload_frameset",(_ns4?parent:null))
	this.f.location.replace(_main._common+"preload_frameset.htm")
}
function helpCB(over)
{
	setHelpText(over?(PL.paused?_lab.contPreloadH:_lab.pausePreloadH):"")
}
function getButton(paused,init)
{
	var obj = gui.preload
	if ( paused == null )
		return _main.skinImg("notile.gif","br",0,0,obj.rw,obj.h,obj.dx+obj.lpw+obj.lcw,0,null,null,trLnk("preloadlink","SwitchPreload()",obj.rw,obj.h,null,null,"helpCB(true)","helpCB(false)"))
	else
	{
		var txt = (paused?_lab.contPreload:_lab.pausePreload)
		if (init)
			return wriTxt('&nbsp;'+txt+'&nbsp;',"btnpreloadtext",null,null,null,"preload")

		var lw = (paused?obj.lcw:obj.lpw)
		var dx = obj.dx+(paused?0:obj.lcw)
		return _main.skinImg("htile.gif","btn",0,0,obj.w,obj.h,0,obj.dy,null,null,
			_main.skinImg("notile.gif","bl",0,0,lw,obj.h,dx,0)+
			wriTxt('&nbsp;'+txt,"btnpreloadtext",null,obj.lcw,obj.txtt,"preload")+
			trLnk("preloadlink","SwitchPreload()",obj.w,obj.h,null,null,"helpCB(true)","helpCB(false)"))
	}
}
function rewrite_preloadCB(w,h) 
{
	var r = w-gui.bgpreload.margin
	moveLayer("bgpreload",r-gui.bgpreload.w,gui.bgpreload.t)
	moveLayer("btnpreload_right",r-gui.preload.rw-gui.bgpreload.rw,gui.bgpreload.t+gui.preload.t)
	if ( !this.paused )
	{
		moveLayer("btnpreload_pause",sw,gui.bgpreload.t+gui.preload.t)
		moveLayer("btnpreload_continue",r-gui.preload.w-gui.bgpreload.rw,gui.bgpreload.t+gui.preload.t)
		moveLayer("txt_pause",sw,gui.bgpreload.t+gui.preload.t)
		moveLayer("txt_continue",r-gui.bgpreload.w+gui.bgpreload.lw,gui.bgpreload.t+gui.bgpreload.txtt)
	}
	else
	{
		moveLayer("btnpreload_pause",r-gui.preload.w-gui.bgpreload.rw,gui.bgpreload.t+gui.preload.t)
		moveLayer("btnpreload_continue",sw,gui.bgpreload.t+gui.preload.t)
		moveLayer("txt_pause",r-gui.bgpreload.w+gui.bgpreload.lw,gui.bgpreload.t+gui.bgpreload.txtt)
		moveLayer("txt_continue",sw,gui.bgpreload.t+gui.preload.t)
	}
	showLayers(true,"bgpreload","btnpreload_right","btnpreload_pause","btnpreload_continue","txt_pause","txt_continue")
}
function resize_preloadCB(w,h) 
{	
	if( this.cleared ) return
	this.rewrite(w,h)
}

function clear_preloadCB()
{
	moveLayer("bgpreload",-sw,0)
	moveLayer("btnpreload_pause",-sw,0)
	moveLayer("btnpreload_continue",-sw,0)
	moveLayer("btnpreload_right",-sw,0)
	moveLayer("txt_pause",-sw,0)
	moveLayer("txt_continue",-sw,0)
	this.cleared = true
	
	gui.bgpreload.w=null
	SLD.resize()
}

function info_preloadCB( text )
{
	reWriteLayer('<span class="preload"><nobr>&nbsp;'+text+'</nobr></span>',"txt_continue")
	reWriteLayer('<span class="preload"><nobr>&nbsp;'+text+'</nobr></span>',"txt_pause")
}
function SwitchPreload()
{
	with(PL)
	{
		if(paused) f.preload_continue();
		else f.preload_pause();
		paused = ! paused
		rewrite(winWidth(),winHeight())
	}
}
var PL = new Preload()